//+------------------------------------------------------------------+
//|                                                  NeuroCandle.mq4 |
//|                             Copyright  2007, Victor I/ Nicolaev |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Victor I. Nicolaev"
#property link      "vinin@mail.ru"
//---- input parameters

#define CMD_OPEN_BUY   0
#define CMD_OPEN_SELL  1
#define CMD_CLOSE_BUY  2
#define CMD_CLOSE_SELL 3
#define CMD_NO         4

extern int mode=-1; //      0  4
extern int iPeriod=-1; //   -1, 0 - , 1 - 4- , 2 - 
extern int icmd=-1;  //   ( )
extern int counttester=0; //   


extern int tp= 100; 
extern int sl= 100; 

extern int MaximumRisk = 10; 

int TM[]={1440,240,60}; 
int prevtime[]={0,0,0,0}; 
int Magic[]={200701,200702,200703}; 
int cmd[]={CMD_NO,CMD_NO,CMD_NO}; 
int TP[]={163,132,83};
int SL[]={80,35,40};

string _comment=""; 
int Command[3][250]; 
#include <Statistika.mqh>
double StartBalance,MaxEqu,MaxDD;
string _symbol;
double WW[250][9];

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   KOHReadMem(WW); // 
   ArrayInitialize(Command,-1); CommandReadMEM();
   int i,j,k;
   if (IsTesting()) {
      StartBalance = AccountBalance();
      MaxEqu = 0;
      MaxDD = 0;
      for (k=0;k<3;k++) {
         for (i=0;i<250;i++)
            if (CheckGlobalVariable("Command",k,i))
                  Command[k,i]=GetGlobalVariable("Command",k,i);
      }
   }   
   if (iPeriod!=-1 && mode!=-1) Command[iPeriod,icmd]=mode;
   return(0); 
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){
   HistoryCalculate(); 
   int i,j,k;
      if (IsTesting()) {
         if (AccountEquity() > MaxEqu) MaxEqu = AccountEquity();
         if (MaxEqu-AccountEquity() > MaxDD) MaxDD = MaxEqu-AccountEquity();
         double Criterion_old = 0;
         if (CheckGlobalVariable("Criterion",iPeriod)) Criterion_old=GetGlobalVariable("Criterion",iPeriod);
            double Criterion = AccountBalance()-StartBalance;
         if( Criterion>Criterion_old) {
            SetGlobalVariable("Command",Command[iPeriod,icmd],iPeriod,icmd);
         SetGlobalVariable("Criterion",Criterion,iPeriod);
         }
      }   
   return(0); 
  }

int start(){
   _symbol=Symbol();
   if (AccountEquity() > MaxEqu) MaxEqu = AccountEquity();
   if (MaxEqu-AccountEquity() > MaxDD) MaxDD = MaxEqu-AccountEquity();

   int nevtime=iTime(_symbol,15,0);
   if (nevtime==prevtime[4]) return(0);
   prevtime[4]=nevtime;
   if (iPeriod==-1) 
      for (int i=0; i<3; i++) {
//         if (iBars(_symbol,TM[i])<BarCount) return(0);  //    ,   .
         start_period(i); 
      }
   else {
      if (sl!=-1) SL[iPeriod]=sl;
      if (tp!=-1) TP[iPeriod]=tp;
      start_period(iPeriod); 
   }
}

int start_period(int P) {
   int cmdKoh,cmd_open=-1,cmd_close=-1, cmd_nev=-1;  
   
   int nevtime=iTime(_symbol,TM[P],0) ;
   if (nevtime== prevtime[P]) return(0); 
   prevtime[P] = nevtime; 
   double MA1=iMA(_symbol,TM[P],5,0,MODE_SMA,PRICE_CLOSE,1);
   double MA2=iMA(_symbol,TM[P],5,0,MODE_SMA,PRICE_CLOSE,2);
   int TrendNev=ComparePrice(MA1,MA2,0.00001);
/*
    
*/
   cmdKoh=KOHWork(); 
   cmd_nev=Command[P,cmdKoh];
   if (cmd_nev>=2 && cmd_nev<=3) cmd_close=cmd_nev;
   if (cmd_nev>=0 && cmd_nev<=1) cmd_open=cmd_nev;
   if (cmd_close-cmd[P]==2 && cmd[P]!=-1) {Order_Close(cmd[P],P); cmd[P]=-1;}
   _comment=P+";"+cmdKoh+";"+cmd_open;
   if(TotalMagic(P)==0 && cmd_open>=0 && cmd_open<=1) {Order_Open(cmd_open,P); cmd[P]=cmd_open; }
   return(0); 
  }
//+------------------------------------------------------------------+
//   
double getLots() {
   double minlot=MarketInfo(_symbol,MODE_MINLOT);
   int round = MathAbs(MathLog(minlot) / MathLog(10.0)) + 0.5; 
   double lot = minlot; 
   double AFM=AccountFreeMargin();
   lot = NormalizeDouble(AFM * MaximumRisk / 100000.0, round); 
   double MR=MarketInfo(_symbol, MODE_MARGINREQUIRED);
   if (AFM < lot * MR)  lot = NormalizeDouble(AFM / MR, round); 
   if(lot < minlot) lot = minlot; 
   double maxlot = MarketInfo(_symbol, MODE_MAXLOT); 
   if(lot > maxlot) lot = maxlot; 
//---- return lot size
   return(lot); 
}

//      
int TotalMagic(int P){
   int Count=0; 
   int total = OrdersTotal(); 
   for (int i = 0;  i < total;  i++) 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == _symbol)
            if (OrderMagicNumber() == Magic[P])
               Count++; 
   return(Count); 
}



bool Order_Modify(int P){
   double _sl, _tp; 
   int _cmd; 
   int total= OrdersTotal();    
   bool find=true;
   for(int i = total - 1;  i >= 0;  i--) 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == _symbol)
            if (OrderMagicNumber() == Magic[P]) {
               _cmd=-Sign(OrderType()-0.5); 
               _sl=iif(SL[P]==0,0,iif(_cmd>0,Bid,Ask) - _cmd*SL[P] * Point); 
               _tp=iif(TP[P]==0,0,iif(_cmd>0,Bid,Ask) + _cmd*TP[P] * Point); 
               if ((_sl-OrderStopLoss())*_cmd>3*Point)
                  OrderModify(OrderTicket(), OrderOpenPrice(), _sl, _tp, 0, iif(_cmd>0,Blue,Red)); 
            }
}


void Order_Close(int cmd, int P){
   int total= OrdersTotal();    
   bool find=true;
   for(int i = total - 1;  i >= 0;  i--) 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         if (OrderSymbol() == _symbol )
            if (OrderMagicNumber() == Magic[P])
               if (OrderType()==cmd)
                  OrderClose(OrderTicket(), OrderLots(), iif(cmd==OP_BUY,Bid,Ask), 3, iif(cmd==OP_BUY,Red,Blue)); 
}

int Sign(double A) {if(A>0) return(1); if(A<0) return(-1); return(0); }
double iif(bool A, double B, double C) {if(A) return(B); return(C); }

int Order_Open(int cmd,int P){
   int _cmd=-Sign(cmd-0.5); 
   double price= iif(cmd==OP_BUY,Ask,Bid); 
   double lots=getLots(); 
//   lots=1;
//   Print(lots);
   double _sl, _tp; 
         _sl=iif(SL[P]==0,0,iif(_cmd>0,Bid,Ask) - _cmd*SL[P] * Point); 
         _tp=iif(TP[P]==0,0,iif(_cmd>0,Bid,Ask) + _cmd*TP[P] * Point);          
   int ticket=OrderSend(_symbol, cmd, lots,price, 3,_sl, _tp,_comment,Magic[P], 0, iif(cmd==OP_BUY,Blue,Red)); 
   return(ticket); 
}

   
string PeriodToStr(int P){
   string sRetVal="_"; 
   switch (P) {
      case PERIOD_M1:  {sRetVal="M1";  break; }
      case PERIOD_M5:  {sRetVal="M5";  break; }
      case PERIOD_M15: {sRetVal="M15";  break; }
      case PERIOD_M30: {sRetVal="M30";  break; }
      case PERIOD_H1:  {sRetVal="H1";  break; }
      case PERIOD_H4:  {sRetVal="H4";  break; }
      case PERIOD_D1:  {sRetVal="D1";  break; }
      case PERIOD_W1:  {sRetVal="W1";  break; }
      case PERIOD_MN1: {sRetVal="MN1";  break; }
   }
   return(sRetVal); 
}
 
int ComparePrice(double a, double b, double digit){
    a -= b;
    b = digit;
    if (a > b) return (1);
    if (a <-b)return (-1);
    return (0);
}

void CommandReadMEM(){


}

//      

bool CheckGlobalVariable(string sVar,int i=0, int j=0){
   string stmp=sVar;   
   if (i<10) stmp=stmp+"0"+i; else stmp=stmp+i; 
   if (j<10) stmp=stmp+"00"+j; 
   else if (j<100) stmp=stmp+"0"+j; 
   else stmp=stmp+j;
   return(GlobalVariableCheck(stmp));
}


void SetGlobalVariable(string sVar,double dVar,int i=0, int j=0){
   string stmp=sVar;   
   if (i<10) stmp=stmp+"0"+i; else stmp=stmp+i; 
   if (j<10) stmp=stmp+"00"+j; 
   else if (j<100) stmp=stmp+"0"+j; 
   else stmp=stmp+j;
   GlobalVariableSet(stmp, dVar);
}

double GetGlobalVariable(string sVar,int i=0, int j=0){
   string stmp=sVar;   
   if (i<10) stmp=stmp+"0"+i; else stmp=stmp+i; 
   if (j<10) stmp=stmp+"00"+j; 
   else if (j<100) stmp=stmp+"0"+j; 
   else stmp=stmp+j;

   return(GlobalVariableGet(stmp));
}


int KOHWork(){
   int i,j;
   double out[]; //     
   ArrayInitialize(out,0);
   double dr,drmax;
//   for (j=0;j<NeuronCount;j++)
//      for (i=0;i<CandleCount;i++)
//         out[j]+=(Candle[i]-WW[i,j])*(Candle[i]-WW[i,j]);
   int min=ArrayMinimum(out);
   return(min);
}


void KOHReadMem(double &WW[][]) {

}